//
//  PhobosDataManager.h
//  GMCache
//
//  Created by Locus on 2020/1/21.
//

#import <Foundation/Foundation.h>
#import <MagicalRecord/MagicalRecord.h>
#import "PhobosSendDataEntity+CoreDataClass.h"

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSInteger, PhobosDataSendStatus) {
    PhobosDataSendStatusToBeSend       = 1, // 待发送数据
    PhobosDataSendStatusSending        = 2, // 发送中数据
    PhobosDataSendStatusFinish         = 3, // 发送完成数据
    PhobosDataSendStatusError          = 4, // 发送失败数据
};

@interface PhobosDataManager : NSObject

/** 获取待发送数据，包含待发送数据和发送失败数据 */
+ (NSArray<PhobosSendDataEntity *> *)fetchToBeSendDataEntities;
+ (NSArray<PhobosSendDataEntity *> *)fetchDataEntitiesWithPredicate:(NSPredicate *)searchFilter;
+ (NSUInteger)fetchCountOfToBeSendEntities;
+ (NSUInteger)fetchCountOfEntitiesWithPredicate:(NSPredicate *)searchFilter;

+ (void)insertData:(NSDictionary *)data sendAPI:(NSString *)sendAPI;

+ (void)updateDataEntities:(NSArray<PhobosSendDataEntity *> *)entities sendStatus:(PhobosDataSendStatus)sendStatus;

+ (void)deleteDataEntities:(NSArray<PhobosSendDataEntity *> *)entities;
+ (void)deleteAllEntities;

@end

NS_ASSUME_NONNULL_END
